# topologia 2 LAN + link, zrodlo TCP, losowe straty, logowanie wielkosci okna
# ok 24.03.2006

# simulator object
set ns [new Simulator]

ns random 127

# nam trace
set nf [open out.nam w]
$ns namtrace-all $nf

# output trace
set tf [open out.tr w]
$ns trace-all $tf


# finish function
proc finish {} {
        global ns nf tf
        $ns flush-trace
        close $nf
		close $tf
        exec nam out.nam &
        exit 0
}
# actual code goes here
# logowanie wielkosci okna do pliku
proc tcpWindow {tcpSource file} {
global ns
set time 0.1
set now [$ns now]
set cwnd [$tcpSource set cwnd_]
puts $file "$now $cwnd"
$ns at [expr $now + $time] "tcpWindow $tcpSource $file"
}

set winfile [open win.tr w]


# ------------------------------------------------------------
# topology
# ------------------------------------------------------------
$ns color 1 Blue
$ns color 2 Red


set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]
set n4 [$ns node]
set n5 [$ns node]

$ns duplex-link $n0 $n2 2Mb 10ms DropTail
$ns duplex-link $n1 $n2 2Mb 10ms DropTail
$ns duplex-link $n2 $n3 300Kb 100ms DropTail
$ns duplex-link $n3 $n4 500Kb 40ms DropTail
$ns duplex-link $n3 $n5 500Kb 40ms DropTail

$ns duplex-link-op $n0 $n2 orient right-down      
$ns duplex-link-op $n1 $n2 orient right-up 
$ns duplex-link-op $n2 $n3 orient right 
$ns duplex-link-op $n3 $n4 orient right-down      
$ns duplex-link-op $n3 $n5 orient right-up 


# ------------------------------------------------------------
# agents
# ------------------------------------------------------------

#definicja agenta TCP
set tcp [new Agent/TCP]
$ns attach-agent $n0 $tcp
set tcp_sink [new Agent/TCPSink]
$ns attach-agent $n5 $tcp_sink

$ns connect $tcp $tcp_sink
#ustawienie FTP
set ftp [new Application/FTP]
$ftp attach-agent $tcp

set loss_module [new ErrorModel]
$loss_module set rate_ 0.20
$loss_module ranvar [new RandomVariable/Uniform]
$loss_module drop-target [new Agent/Null]
$ns lossmodel $loss_module $n2 $n3

# ------------------------------------------------------------
# dynamic events
# ------------------------------------------------------------
$ns at 0.1 "tcpWindow $tcp $winfile"


$ns at 0.1 "$ftp start"
$ns at 4.1 "$ftp stop"


# ------------------------------------------------------------
# finish & start simulator
$ns at 5.0 "finish"
$ns run

# ------------------------------------------------------------
# agents
# ------------------------------------------------------------


