# topologia 2 LAN + link, zrodlo TCP i UDP, kolorowanie pakietow, monitorowanie kolejki, awaria lacza 
# ok 22.03.2006

# simulator object
set ns [new Simulator]

# output trace
set nf [open out.nam w]
$ns namtrace-all $nf

set tf [open out.tr w]
$ns trace-all $tf

# finish function
proc finish {} {
        global ns nf tf
        $ns flush-trace
        close $nf
		close $tf
        exec nam out.nam &
        exit 0
}
# actual code goes here
# ------------------------------------------------------------
# topology
# ------------------------------------------------------------
set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]
set n4 [$ns node]
set n5 [$ns node]

$ns duplex-link $n0 $n2 2Mb 10ms DropTail
$ns duplex-link $n1 $n2 2Mb 10ms DropTail
$ns duplex-link $n2 $n3 300Kb 100ms DropTail
$ns duplex-link $n3 $n4 500Kb 40ms DropTail
$ns duplex-link $n3 $n5 500Kb 40ms DropTail

$ns duplex-link-op $n0 $n2 orient right-down      
$ns duplex-link-op $n1 $n2 orient right-up 
$ns duplex-link-op $n2 $n3 orient right 
$ns duplex-link-op $n3 $n4 orient right-down      
$ns duplex-link-op $n3 $n5 orient right-up 

$ns duplex-link-op $n2 $n3 queuePos 0.5
# ------------------------------------------------------------
# agents
# ------------------------------------------------------------

$ns color 1 Blue
$ns color 2 Red

#definicja agenta TCP
set tcp [new Agent/TCP]
$tcp set class_ 1
$ns attach-agent $n0 $tcp
set tcp_sink [new Agent/TCPSink]
$ns attach-agent $n4 $tcp_sink


$ns connect $tcp $tcp_sink
#ustawienie FTP
set ftp [new Application/FTP]
$ftp attach-agent $tcp


set udp0 [new Agent/UDP]
$udp0 set class_ 2
$ns attach-agent $n1 $udp0
#Tworzymy rdo danych typu CBR i doczamy je do udp0
set cbr0 [new Application/Traffic/CBR]
$cbr0 set packetSize_ 500
$cbr0 set interval_ 0.05
$cbr0 attach-agent $udp0


set null0 [new Agent/Null]
$ns attach-agent $n5 $null0
$ns connect $udp0 $null0


# ------------------------------------------------------------
# dynamic events
# ------------------------------------------------------------
$ns at 0.1 "$ftp start"
$ns at 4.1 "$ftp stop"

$ns at 0.1 "$cbr0 start"
$ns at 4.1 "$cbr0 stop"

$ns rtmodel-at 2.0 down $n2 $n3
$ns rtmodel-at 3.0 up $n2 $n3

# ------------------------------------------------------------
# finish & start simulator
$ns at 5.0 "finish"
$ns run
